#include "tclInt.h"
#include "ext_ttc.h"


extern int stkctr ;
extern Tcl_Interp * stk [] ;
extern Tcl_Interp * shared_interp ;




char * new_frame (frame) int frame ; {

  char  tmp[1000] ;


  switch (frame) {
  case CMD_SUB:
    sprintf (tmp, "cmd_sub_frame_%d", cmd_sub_count) ;
    ++cmd_sub_count ;
    break ;
  case VAR_SUB:
    sprintf (tmp, "var_sub_frame_%d", var_sub_count) ;
    ++var_sub_count ;
    break ;
  }
  return (strdup (tmp)) ;
}


res () {

  printf ("result : %s\n" , STACKTOP->result) ;

}
shres () {

  printf ("shared-result : %s\n" , shared_interp->result) ;

}


char * ypush (function_purpose , function_name) 
int    function_purpose ;
char * function_name ;
{
  char tmp_string[1000] , cmd[1000] ;


  ++stkctr ;
  STACKTOP = (Tcl_Interp *) Tcl_CreateInterp () ;

  c_string_to_tcl_var (STACKTOP, function_name, "func_name") ;
  sprintf(tmp_string,"%d",function_purpose) ;
  c_string_to_tcl_var (STACKTOP, tmp_string, "func_purpose")         ; res () ;

  Tcl_VarEval (STACKTOP,"source ttc.tcl ;", (char *) NULL)  ; res () ;

  Tcl_VarEval (STACKTOP,"set c_code {} ;"           , (char *) NULL) ; res () ;

  Tcl_VarEval (STACKTOP, "test ;"                   , (char *) NULL) ; res () ;
  Tcl_VarEval (STACKTOP, "create_function_header;" , (char *) NULL)  ; res () ;

  return (function_name) ;
}


char * ypop () {
  char retval[1000] , * source ;
  
  strcpy (retval , Tcl_GetVar (STACKTOP, "func_name", TCL_GLOBAL_ONLY)) ;
  
  res () ;
  Tcl_VarEval (STACKTOP , "source ttc.tcl ;", (char *) NULL) ;
  res () ;
  Tcl_VarEval (STACKTOP , "close_function ;", (char *) NULL) ;
  res () ;
  source = (char *) malloc (strlen(Tcl_GetVar (STACKTOP, "c_code",TCL_GLOBAL_ONLY))+1) ;
  strcpy (source , Tcl_GetVar (STACKTOP, "c_code",TCL_GLOBAL_ONLY)) ;

  printf ("------------------\n") ;
  res () ;
  printf ("SOURCE CODE: %s\n", source) ;
  Tcl_VarEval (shared_interp, "puts $fp {", source, "\n\n} ; flush $fp ;", (char *) NULL) ;  
  res () ;
  printf ("------------------\n") ;


  Tcl_DeleteInterp (STACKTOP) ;
  
  --stkctr ;
  return (strdup(retval)) ;
}


c_string_to_tcl_var (interp, string, tcl_var) 
Tcl_Interp * interp ;
char * tcl_var , * string ;
{
  char cmd_str[1000] ;

  sprintf (cmd_str , "set %s [list %s]" , tcl_var , string) ;
  Tcl_GlobalEval (interp, cmd_str) ;
/*  res () ;*/
}

prep_args (int purpose, char * proc_args)  {
  
  switch (purpose) {

  case TCL_CMD:
    c_string_to_tcl_var (STACKTOP, proc_args, "proc_args" ) ;
    Tcl_VarEval (STACKTOP,"append c_code [codeForArgumentBinding $proc_args]", (char *) NULL) ;
    res () ;
    break ;
  case CMD_SUB:
       ;
    break ;
  case VAR_SUB:
   Tcl_VarEval (STACKTOP,"append c_code {char  name_1 [500] , name_2 [500] ;\n\n};", (char *) NULL) ;
    break ;
  }

}


append_c_code (string) char * string ; {

  char tmp_string [1000] ;

  sprintf (tmp_string, "catch {append c_code {%s}}", string) ;
  Tcl_Eval (STACKTOP, tmp_string, NULL, NULL) ;
  
}


strcpy_into (var_name,string) char * var_name, * string ; {

  char tmp_string [1000] ;

  sprintf (tmp_string, "strcpy (%s,%s) ;\n", var_name,string) ;
  append_c_code (tmp_string) ;

}

strcat_onto (var_name,string) char * var_name; char * string ; {

  char tmp_string [1000] ;

  sprintf (tmp_string, "strcat (%s,%s) ;\n", var_name,string) ;
  append_c_code (tmp_string) ;

}

char * pass_interp_to_frame (frame) char * frame ; {

  char tmp_string [1000] ;

  sprintf (tmp_string, "%s(interp)", frame) ;
  
  return strdup(tmp_string) ;

}

char * quote (char * string) {

  char tmp_string[1000] ;

  tmp_string[0]='\"' ;
  tmp_string[1]='\0' ;
  strcat  (tmp_string, string) ;
  strcat  (tmp_string, "\"") ;  

  printf ("quoted string: %s\n" , tmp_string) ;

  return strdup (tmp_string) ;

}
